static const char *default_lua = 
	"function naim.prototypes.windows.event(window, e, s)\n"
	"	if window.eventtab and window.eventtab[e] then\n"
	"		window.eventtab[e].func(window, e, s)\n"
	"	elseif window.eventtab and window.eventtab.default then\n"
	"		window.eventtab.default.func(window, e, s)\n"
	"	elseif window.conn.eventtab and window.conn.eventtab[e] then\n"
	"		window.conn.eventtab[e].func(window, e, s)\n"
	"	elseif window.conn.eventtab and window.conn.eventtab.default then\n"
	"		window.conn.eventtab.default.func(window, e, s)\n"
	"	elseif naim.eventtab[e] then\n"
	"		naim.eventtab[e].func(window, e, s)\n"
	"	elseif naim.eventtab.default then\n"
	"		naim.eventtab.default.func(window, e, s)\n"
	"	end\n"
	"end\n"
	"\n"
	"function naim.internal.eventeval(code)\n"
	"	local functabfunc = assert(loadstring(\"return {\" .. (code and code or \"\") .. \"}\"))\n"
	"\n"
	"	setfenv(functabfunc, {\n"
	"		display = function(window, e, s)\n"
	"			if s then\n"
	"				window:echo(s)\n"
	"			end\n"
	"		end,\n"
	"		notify = function(window, e, s)\n"
	"			window:notify()\n"
	"		end,\n"
	"		ignore = function(window, e, s)\n"
	"		end,\n"
	"		naim = naim,\n"
	"		string = string,\n"
	"	})\n"
	"\n"
	"	local functab = functabfunc()\n"
	"\n"
	"	if #functab == 0 then\n"
	"		return nil\n"
	"	else\n"
	"		return {\n"
	"			func = function(w, e, s)\n"
	"				for _,f in ipairs(functab) do\n"
	"					f(w, e, s)\n"
	"				end\n"
	"			end,\n"
	"			code = code,\n"
	"		}\n"
	"	end\n"
	"end\n"
	"\n"
	"function naim.internal.rwmetatable(prototype)\n"
	"	return({\n"
	"		__index = function(table, key)\n"
	"			if prototype[key] ~= nil then\n"
	"				return prototype[key]\n"
	"			elseif prototype[\"get_\"..key] ~= nil then\n"
	"				return prototype[\"get_\"..key](table.handle)\n"
	"			else\n"
	"				return nil\n"
	"			end\n"
	"		end,\n"
	"		__newindex = function(table, key, value)\n"
	"			if prototype[\"set_\"..key] ~= nil then\n"
	"				prototype[\"set_\"..key](table.handle, key, value)\n"
	"			elseif prototype[\"get_\"..key] ~= nil then\n"
	"				error(key .. \" is a read-only attribute\",2)\n"
	"			else\n"
	"				rawset(table, key, value)\n"
	"			end\n"
	"		end,\n"
	"		__tostring = function(table)\n"
	"			return(table.name)\n"
	"		end,\n"
	"	})\n"
	"end\n"
	"\n"
	"function naim.internal.rometatable(name)\n"
	"	return({\n"
	"		__newindex = function (t,k,v)\n"
	"			error(\"only naim can update the \" .. name .. \" table\", 2)\n"
	"		end\n"
	"	})\n"
	"end\n"
	"\n"
	"naim.name = \"default\"\n"
	"\n"
	"naim.variables = {}\n"
	"\n"
	"naim.sockets = {}\n"
	"\n"
	"naim.connections = {}\n"
	"setmetatable(naim.connections, naim.internal.rometatable(\"connections\"))\n"
	"\n"
	"do\n"
	"	local display = naim.internal.eventeval(\"display\")\n"
	"	local notify = naim.internal.eventeval(\"display,notify\")\n"
	"\n"
	"	naim.eventtab = {\n"
	"		message = notify,\n"
	"		attacked = notify,\n"
	"		attacks = notify,\n"
	"		default = display,\n"
	"	}\n"
	"end\n"
	"\n"
	"function naim.internal.varsub(s, t)\n"
	"	s = string.gsub(s, \"$%((.*)%)\",\n"
	"		function(n)\n"
	"			return(loadstring(\"return \" .. n)())\n"
	"		end)\n"
	"	s = string.gsub(s, \"$\\{([a-zA-Z0-9:_]+)\\}\",\n"
	"		function(n)\n"
	"			return(t[n])\n"
	"		end)\n"
	"	s = string.gsub(s, \"$([a-zA-Z0-9:_]+)\",\n"
	"		function(n)\n"
	"			return(t[n])\n"
	"		end)\n"
	"	return(s)\n"
	"end\n"
	"\n"
	"function naim.internal.expandstring(s)\n"
	"	return(naim.internal.varsub(s, naim.variables))\n"
	"end\n"
	"\n"
	"function naim.internal.newconn(winname, handle)\n"
	"	setmetatable(naim.connections, {})\n"
	"	naim.connections[winname] = {\n"
	"		handle = handle,\n"
	"		name = winname,\n"
	"		windows = {},\n"
	"		buddies = {},\n"
	"		groups = {},\n"
	"	}\n"
	"	setmetatable(naim.connections[winname], naim.internal.rwmetatable(naim.prototypes.connections))\n"
	"	setmetatable(naim.connections[winname].windows, naim.internal.rometatable(\"windows\"))\n"
	"	setmetatable(naim.connections[winname].buddies, naim.internal.rometatable(\"buddies\"))\n"
	"	setmetatable(naim.connections, naim.internal.rometatable(\"connections\"))\n"
	"end\n"
	"\n"
	"function naim.internal.delconn(winname)\n"
	"	setmetatable(naim.connections, {})\n"
	"	naim.connections[winname] = nil\n"
	"	setmetatable(naim.connections, naim.internal.rometatable(\"connections\"))\n"
	"end\n"
	"\n"
	"function naim.internal.newwin(conn, winname, handle)\n"
	"	setmetatable(conn.windows, {})\n"
	"	conn.windows[winname] = {\n"
	"		handle = handle,\n"
	"		conn = conn,\n"
	"		name = winname,\n"
	"	}\n"
	"	setmetatable(conn.windows[winname], naim.internal.rwmetatable(naim.prototypes.windows))\n"
	"	setmetatable(conn.windows, naim.internal.rometatable(\"windows\"))\n"
	"end\n"
	"\n"
	"function naim.internal.delwin(conn, winname)\n"
	"	setmetatable(conn.windows, {})\n"
	"	conn.windows[winname] = nil\n"
	"	setmetatable(conn.windows, naim.internal.rometatable(\"windows\"))\n"
	"end\n"
	"\n"
	"function naim.internal.newbuddy(conn, account, handle)\n"
	"	setmetatable(conn.buddies, {})\n"
	"	conn.buddies[account] = {\n"
	"		handle = handle,\n"
	"		conn = conn,\n"
	"		name = account,\n"
	"	}\n"
	"	setmetatable(conn.buddies[account], naim.internal.rwmetatable(naim.prototypes.buddies))\n"
	"	setmetatable(conn.buddies, naim.internal.rometatable(\"buddies\"))\n"
	"end\n"
	"\n"
	"function naim.internal.changebuddy(conn, account, newaccount)\n"
	"	setmetatable(conn.buddies, {})\n"
	"	conn.buddies[newaccount] = conn.buddies[account]\n"
	"	conn.buddies[account] = nil\n"
	"	setmetatable(conn.buddies, naim.internal.rometatable(\"buddies\"))\n"
	"end\n"
	"\n"
	"function naim.internal.delbuddy(conn, account)\n"
	"	setmetatable(conn.buddies, {})\n"
	"	conn.buddies[account] = nil\n"
	"	setmetatable(conn.buddies, naim.internal.rometatable(\"buddies\"))\n"
	"end\n"
	"\n"
	"\n"
	"\n"
	"\n"
	"\n"
	"\n"
	"function naim.call(tab, ...)\n"
	"	local conn\n"
	"	local min = tab.min\n"
	"	local max = tab.max\n"
	"\n"
	"	local isconn = function(conn)\n"
	"		for k,v in pairs(naim.connections) do\n"
	"			if v == conn then\n"
	"				return(k)\n"
	"			end\n"
	"		end\n"
	"		return(nil)\n"
	"	end\n"
	"\n"
	"	arg.n = nil\n"
	"\n"
	"	if arg[1] == nil or type(arg[1]) == \"string\" then\n"
	"		conn = naim.curconn()\n"
	"	elseif isconn(arg[1]) then\n"
	"		conn = table.remove(arg, 1)\n"
	"	elseif arg[1].conn == nil then\n"
	"		naim.echo(\"invalid first argument to \" .. tostring(tab))\n"
	"		return\n"
	"	else\n"
	"		conn = arg[1].conn\n"
	"		arg[1] = tostring(arg[1])\n"
	"	end\n"
	"\n"
	"	if #arg == 1 then\n"
	"		local newarg = {}\n"
	"		local i = 1\n"
	"\n"
	"		arg = arg[1]\n"
	"		while i < max and arg ~= nil do\n"
	"			newarg[i],arg = naim.internal.pullword(arg)\n"
	"			i = i+1\n"
	"		end\n"
	"		assert(#newarg == i-1)\n"
	"		if (arg ~= nil) then\n"
	"			newarg[i] = arg\n"
	"		end\n"
	"		arg = newarg\n"
	"	end\n"
	"\n"
	"	if #arg > max then\n"
	"		naim.echo(\"Command requires at most \" .. max .. \" arguments.\")\n"
	"		return\n"
	"	elseif #arg < min then\n"
	"		naim.echo(\"Command requires at least \" .. min .. \" arguments.\")\n"
	"		return\n"
	"	end\n"
	"\n"
	"	tab.func(conn, arg)\n"
	"end\n"
	"\n"
	"naim.help = {\n"
	"	topics = {\n"
	"		\"In the top-right corner of your screen is a \\\"window list\\\" window, which will display one window for each online buddy once you have signed on. The window highlighted at the top is the current window. Use the Tab key to cycle through the listed windows, or /jump buddyname to jump directly to buddyname's window.\",\n"
	"		\"\",\n"
	"		\"The window list window will hide itself automatically to free up space for conversation, but it will come back if someone other than your current buddy messages you. You can press Ctrl-N to go to the next waiting (yellow) buddy when this happens.\",\n"
	"	},\n"
	"	about = {\n"
	"		\"naim is a console-mode chat client.\",\n"
	"		\"naim supports AIM, IRC, ICQ, and Lily.\",\n"
	"		\"\",\n"
	"		\"Copyright 1998-2006 Daniel Reed <n@ml.org>\",\n"
	"		\"http://naim.n.ml.org/\",\n"
	"	},\n"
	"}\n"
	"\n"
	"naim.commands.help = {\n"
	"	min = 0,\n"
	"	max = 1,\n"
	"	desc = \"Display topical help on using naim\",\n"
	"	args = { \"topic\" },\n"
	"	func = function(conn, arg)\n"
	"		local found\n"
	"\n"
	"		if #arg == 0 then\n"
	"			arg[1] = \"topics\"\n"
	"		end\n"
	"\n"
	"		local function helpcmd(cmd, t)\n"
	"			local str\n"
	"			local i\n"
	"\n"
	"			str = \"<font color=\\\"#FF00FF\\\">Usage</font>: <font color=\\\"#00FF00\\\">/\" .. cmd .. \"</font>\"\n"
	"			i = 0\n"
	"			while (i < t.min) do\n"
	"				str = str .. \" <font color=\\\"#00FF00\\\">&lt;\" .. t.args[i+1] .. \"&gt;</font>\"\n"
	"				i = i + 1\n"
	"			end\n"
	"			while (i < t.max) do\n"
	"				str = str .. \" [<font color=\\\"#FFFF00\\\">&lt;\" .. t.args[i+1] .. \"&gt;</font>\"\n"
	"				i = i + 1\n"
	"			end\n"
	"			i = t.min\n"
	"			while (i < t.max) do\n"
	"				str = str .. \"]\"\n"
	"				i = i + 1\n"
	"			end\n"
	"			naim.curwin():x_hprint(str .. \"<br>\")\n"
	"			if t.desc ~= nil then\n"
	"				naim.curwin():x_hprint(\"<b>\" .. t.desc .. \"</b><br>\")\n"
	"			end\n"
	"		end\n"
	"\n"
	"		found = true\n"
	"		if arg[1] == \"keys\" then\n"
	"			naim.echo(\"Current key bindings can be viewed at any time with <font color=\\\"#00FF00\\\">/bind</font>:\")\n"
	"			naim.call(naim.commands.bind)\n"
	"			naim.curwin():x_hprint(\"Key names beginning with ^ are entered by holding down the Ctrl key while pressing the listed key: ^N is Ctrl+N.<br>\")\n"
	"			naim.curwin():x_hprint(\"Key names beginning with M- are entered by holding down the Alt key while pressing the key, or by pressing Esc first, then typing the key: M-a is Alt+A.<br>\")\n"
	"			naim.curwin():x_hprint(\"IC is Ins and DC is Del on the numeric keypad. NPAGE and PPAGE are PgDn and PgUp.<br>\")\n"
	"			naim.curwin():x_hprint(\"Type <font color=\\\"#00FF00\\\">/bind &lt;keyname&gt; \\\"&lt;script&gt;\\\"</font> to change a key binding.<br>\")\n"
	"		elseif arg[1] == \"settings\" or arg[1] == \"variables\" then\n"
	"			naim.echo(\"Current configuration settings can be viewed at any time with <font color=\\\"#00FF00\\\">/set</font>:\")\n"
	"			naim.call(naim.commands.set)\n"
	"			naim.curwin():x_hprint(\"Type <font color=\\\"#00FF00\\\">/set &lt;varname&gt; \\\"&lt;new value&gt;\\\"</font> to change a configuration variable.<br>\")\n"
	"		elseif arg[1] == \"commands\" then\n"
	"			naim.echo(\"Help on \" .. tostring(arg[1]) .. \":\")\n"
	"			for cmd,t in pairs(naim.commands) do\n"
	"				helpcmd(cmd, t)\n"
	"				naim.curwin():x_hprint(\"<br>\")\n"
	"			end\n"
	"		else\n"
	"			found = false\n"
	"		end\n"
	"\n"
	"		if naim.commands[arg[1]] ~= nil then\n"
	"			if not found then\n"
	"				naim.echo(\"Help on \" .. tostring(arg[1]) .. \":\")\n"
	"				found = true\n"
	"			end\n"
	"			helpcmd(arg[1], naim.commands[arg[1]])\n"
	"		end\n"
	"\n"
	"		if type(naim.help[arg[1]]) == \"string\" then\n"
	"			if not found then\n"
	"				naim.echo(\"Help on \" .. tostring(arg[1]) .. \":\")\n"
	"				found = true\n"
	"			end\n"
	"			naim.curwin():x_hprint(naim.help[arg[1]] .. \"<br>\")\n"
	"		elseif type(naim.help[arg[1]]) == \"table\" then\n"
	"			if not found then\n"
	"				naim.echo(\"Help on \" .. tostring(arg[1]) .. \":\")\n"
	"				found = true\n"
	"			end\n"
	"			for i,v in ipairs(naim.help[arg[1]]) do\n"
	"				naim.curwin():x_hprint(v .. \"<br>\")\n"
	"			end\n"
	"		end\n"
	"\n"
	"		if not found then\n"
	"			naim.echo(\"No help available for \" .. arg[1] .. \".\")\n"
	"		--else\n"
	"		--	naim.echo(\"Use the scroll keys (PgUp and PgDn or Ctrl-R and Ctrl-Y) to view the entire help.\")\n"
	"		end\n"
	"	end,\n"
	"}\n"
	"\n"
	"naim.commands.listevents = {\n"
	"	min = 0,\n"
	"	max = 0,\n"
	"	desc = \"EXPERIMENTAL List active event handlers\",\n"
	"	args = {},\n"
	"	func = function(conn, arg)\n"
	"		local seen = {}\n"
	"\n"
	"		naim.echo(\"Rules used in the current scope:\")\n"
	"\n"
	"		for _,scope in ipairs({ conn:curwin() ~= conn and conn:curwin() or {}, conn, naim }) do\n"
	"			if scope.eventtab then\n"
	"				for e,t in pairs(scope.eventtab) do\n"
	"					if not seen[e] then\n"
	"						seen[e] = true\n"
	"\n"
	"						local s = \"Scope \" .. scope.name .. \" event \" .. e .. \":\"\n"
	"\n"
	"						naim.echo(\"&nbsp;&nbsp;\" .. s .. string.rep(\"&nbsp;\", 30-s:len()) .. \"&nbsp;\" .. t.code .. \" (\" .. tostring(t.func) .. \")\")\n"
	"					end\n"
	"				end\n"
	"			end\n"
	"		end\n"
	"	end,\n"
	"}\n"
	"\n"
	"naim.commands.on = {\n"
	"	min = 2,\n"
	"	max = 3,\n"
	"	desc = \"EXPERIMENTAL Event behavior control\",\n"
	"	args = { \"target\", \"event\", \"action\" },\n"
	"	func = function(conn, arg)\n"
	"		local target, e, code = unpack(arg)\n"
	"\n"
	"		local function findscope()\n"
	"			local dot = string.find(target, ':')\n"
	"\n"
	"			if dot then\n"
	"				local c, w = target:sub(1, dot-1), target:sub(dot+1)\n"
	"\n"
	"				if not naim.connections[c] then\n"
	"					error(c .. \" is not a valid connection name\")\n"
	"				elseif not w or w == \"\" then\n"
	"					return naim.connections[c]\n"
	"				elseif not naim.connections[c].windows[w] then\n"
	"					error(w .. \" is not a valid window name in \" .. c)\n"
	"				else\n"
	"					return naim.connections[c].windows[w]\n"
	"				end\n"
	"			elseif target == \"default\" then\n"
	"				return naim\n"
	"			elseif conn.windows[target] and naim.connections[target] then\n"
	"				error(target .. \" is both a connection name and a window name; use /on \" .. tostring(conn) .. \":\" .. target .. \" event ... or /on \" .. target .. \": event ...\")\n"
	"			elseif conn.windows[target] then\n"
	"				return conn.windows[target]\n"
	"			elseif naim.connections[target] then\n"
	"				return naim.connections[target]\n"
	"			else\n"
	"				error(\"Unrecognized target \" .. target)\n"
	"			end\n"
	"		end\n"
	"\n"
	"		local scope = findscope()\n"
	"\n"
	"		if e == \"all\" then\n"
	"			scope.eventtab = {}\n"
	"			e = \"default\"\n"
	"		elseif not scope.eventtab then\n"
	"			scope.eventtab = {}\n"
	"		end\n"
	"\n"
	"		local evald = naim.internal.eventeval(code)\n"
	"\n"
	"		if scope.eventtab[e] then\n"
	"			if evald then\n"
	"				naim.echo(\"Changed rule for scope \" .. scope.name .. \" event \" .. e .. \".\")\n"
	"			else\n"
	"				naim.echo(\"Removed rule for scope \" .. scope.name .. \" event \" .. e .. \".\")\n"
	"			end\n"
	"		elseif evald then\n"
	"			naim.echo(\"Added rule for scope \" .. scope.name .. \" event \" .. e .. \".\")\n"
	"		else\n"
	"			naim.echo(\"No rule for scope \" .. scope.name .. \" event \" .. e .. \".\")\n"
	"		end\n"
	"\n"
	"		scope.eventtab[e] = evald\n"
	"	end,\n"
	"}\n"
	"\n"
	"naim.commands.names = {\n"
	"	min = 0,\n"
	"	max = 1,\n"
	"	desc = \"List the users of a group\",\n"
	"	args = { \"group\" },\n"
	"	func = function(conn, arg)\n"
	"		local window\n"
	"\n"
	"		if #arg > 0 and conn.windows[string.lower(arg[1])] then\n"
	"			window = conn.windows[string.lower(arg[1])]\n"
	"		else\n"
	"			window = conn:curwin()\n"
	"		end\n"
	"\n"
	"		local group = conn.groups[string.lower(tostring(window))]\n"
	"\n"
	"		if not group then\n"
	"			return naim.call(naim.commands.buddylist, conn, unpack(arg))\n"
	"		end\n"
	"\n"
	"		local maxlen = 0\n"
	"\n"
	"		for member,info in pairs(group.members) do\n"
	"			local mlen = member:len() + (info.admin and 1 or 0)\n"
	"\n"
	"			if mlen > maxlen then\n"
	"				maxlen = mlen\n"
	"			end\n"
	"		end\n"
	"\n"
	"		local t = {}\n"
	"\n"
	"		for member,info in pairs(group.members) do\n"
	"			local mlen = member:len() + (info.admin and 1 or 0)\n"
	"\n"
	"			table.insert(t, (info.admin and \"@\" or \"\") .. member .. string.rep(\"&nbsp;\", maxlen-mlen))\n"
	"		end\n"
	"\n"
	"		local p = \"Users in group \" .. tostring(window) .. \":\"\n"
	"\n"
	"		window:echo(p .. string.rep(\"&nbsp;\", (maxlen+1)-math.fmod(p:len(), maxlen+1)) .. table.concat(t, \" \"))\n"
	"	end,\n"
	"}\n"
	"\n"
	"\n"
	"\n"
	"\n"
	"\n"
	"naim.hooks.add('proto_buddy_coming', function(conn, who)\n"
	"	\n"
	"end, 100)\n"
	"\n"
	"naim.hooks.add('proto_user_nickchanged', function(conn, who, newnick)\n"
	"	naim.internal.changebuddy(conn, who, newnick)\n"
	"\n"
	"	local window = conn.windows[who]\n"
	"\n"
	"	if window then\n"
	"		window:echo(\"<font color=\\\"#00FFFF\\\">\" .. who .. \"</font> is now known as <font color=\\\"#00FFFF\\\">\" .. newnick .. \"</font>.\")\n"
	"		window.name = newnick\n"
	"		assert(not conn.windows[newnick])\n"
	"		conn.windows[newnick] = conn.windows[who]\n"
	"		conn.windows[who] = nil\n"
	"	end\n"
	"end, 100)\n"
	"\n"
	"naim.hooks.add('proto_chat_joined', function(conn, chat)\n"
	"	assert(not conn.groups[string.lower(chat)])\n"
	"	conn.groups[string.lower(chat)] = {\n"
	"		members = {},\n"
	"	}\n"
	"\n"
	"	local window = conn.windows[string.lower(chat)]\n"
	"\n"
	"	if window then\n"
	"		window:echo(\"You are now participating in the \" .. chat .. \" group.\")\n"
	"	end\n"
	"end, 100)\n"
	"\n"
	"naim.hooks.add('proto_chat_synched', function(conn, chat)\n"
	"	local group = conn.groups[string.lower(chat)]\n"
	"	local window = conn.windows[string.lower(chat)]\n"
	"\n"
	"	group.synched = true\n"
	"\n"
	"	if window and naim.variables.autonames and tonumber(naim.variables.autonames) > 0 then\n"
	"		naim.call(naim.commands.names, conn, chat)\n"
	"	end\n"
	"end, 100)\n"
	"\n"
	"naim.hooks.add('proto_chat_left', function(conn, chat)\n"
	"	assert(conn.groups[string.lower(chat)])\n"
	"	conn.groups[string.lower(chat)] = nil\n"
	"end, 100)\n"
	"\n"
	"naim.hooks.add('proto_chat_kicked', function(conn, chat, by, reason)\n"
	"	assert(conn.groups[string.lower(chat)])\n"
	"	conn.groups[string.lower(chat)] = nil\n"
	"\n"
	"	local window = conn.windows[string.lower(chat)]\n"
	"\n"
	"	if window then\n"
	"		if reason and reason ~= \"\" then\n"
	"			window:event(\"attacked\", \"You have been kicked from group \" .. chat .. \" by <font color=\\\"#00FFFF\\\">\" .. by .. \"</font> (</b><body>\" .. reason .. \"</body><b>).\")\n"
	"		else\n"
	"			window:event(\"attacked\", \"You have been kicked from group \" .. chat .. \" by <font color=\\\"#00FFFF\\\">\" .. by .. \"</font>.\")\n"
	"		end\n"
	"	end\n"
	"end, 100)\n"
	"\n"
	"naim.hooks.add('proto_chat_oped', function(conn, chat, by)\n"
	"	local group = conn.groups[string.lower(chat)]\n"
	"\n"
	"	group.admin = true\n"
	"\n"
	"	if group.synched then\n"
	"		local window = conn.windows[string.lower(chat)]\n"
	"\n"
	"		if window then\n"
	"			window:event(\"attacked\")\n"
	"		end\n"
	"	end\n"
	"end, 100)\n"
	"\n"
	"naim.hooks.add('proto_chat_deoped', function(conn, chat, by)\n"
	"	local group = conn.groups[string.lower(chat)]\n"
	"\n"
	"	group.admin = nil\n"
	"\n"
	"	assert(group.synched)\n"
	"	local window = conn.windows[string.lower(chat)]\n"
	"\n"
	"	if window then\n"
	"		window:event(\"attacked\")\n"
	"	end\n"
	"end, 100)\n"
	"\n"
	"naim.hooks.add('proto_chat_user_joined', function(conn, chat, who, extra)\n"
	"	local group = conn.groups[string.lower(chat)]\n"
	"	local window = conn.windows[string.lower(chat)]\n"
	"\n"
	"	assert(not group.members[who])\n"
	"	group.members[who] = {}\n"
	"\n"
	"	if window and group.synched then\n"
	"		if extra and extra ~= \"\" then\n"
	"			window:event(\"users\", \"<font color=\\\"#00FFFF\\\">\" .. who .. \"</font> (\" .. extra .. \") has joined group \" .. chat .. \".\")\n"
	"		else\n"
	"			window:event(\"users\", \"<font color=\\\"#00FFFF\\\">\" .. who .. \"</font> has joined group \" .. chat .. \".\")\n"
	"		end\n"
	"	end\n"
	"end, 100)\n"
	"\n"
	"naim.hooks.add('proto_chat_user_left', function(conn, chat, who, reason)\n"
	"	local group = conn.groups[string.lower(chat)]\n"
	"	local window = conn.windows[string.lower(chat)]\n"
	"\n"
	"	assert(group.members[who])\n"
	"	group.members[who] = nil\n"
	"\n"
	"	if window then\n"
	"		if reason and reason ~= \"\" then\n"
	"			window:event(\"users\", \"<font color=\\\"#00FFFF\\\">\" .. who .. \"</font> has left group \" .. chat .. \" (</b><body>\" .. reason .. \"</body><b>).\")\n"
	"		else\n"
	"			window:event(\"users\", \"<font color=\\\"#00FFFF\\\">\" .. who .. \"</font> has left group \" .. chat .. \".\")\n"
	"		end\n"
	"	end\n"
	"end, 100)\n"
	"\n"
	"naim.hooks.add('proto_chat_user_kicked', function(conn, chat, who, by, reason)\n"
	"	local group = conn.groups[string.lower(chat)]\n"
	"	local window = conn.windows[string.lower(chat)]\n"
	"\n"
	"	assert(group.members[who])\n"
	"	group.members[who] = nil\n"
	"\n"
	"	if window then\n"
	"		if reason and reason ~= \"\" then\n"
	"			window:event(\"attacks\", \"<font color=\\\"#00FFFF\\\">\" .. who .. \"</font> has been kicked out of group \" .. chat .. \" by <font color=\\\"#00FFFF\\\">\" .. by .. \"</font> (</b><body>\" .. reason .. \"</body><b>).\")\n"
	"		else\n"
	"			window:event(\"attacks\", \"<font color=\\\"#00FFFF\\\">\" .. who .. \"</font> has been kicked out of group \" .. chat .. \" by <font color=\\\"#00FFFF\\\">\" .. by .. \"</font>.\")\n"
	"		end\n"
	"	end\n"
	"end, 100)\n"
	"\n"
	"naim.hooks.add('proto_chat_user_oped', function(conn, chat, who, by)\n"
	"	local group = conn.groups[string.lower(chat)]\n"
	"\n"
	"	group.members[who].admin = true\n"
	"\n"
	"	if group.synched then\n"
	"		local window = conn.windows[string.lower(chat)]\n"
	"\n"
	"		if window then\n"
	"			window:event(\"attacks\")\n"
	"		end\n"
	"	end\n"
	"end, 100)\n"
	"\n"
	"naim.hooks.add('proto_chat_user_deoped', function(conn, chat, who, by)\n"
	"	local group = conn.groups[string.lower(chat)]\n"
	"\n"
	"	group.members[who].admin = nil\n"
	"\n"
	"	assert(group.synched)\n"
	"	local window = conn.windows[string.lower(chat)]\n"
	"\n"
	"	if window then\n"
	"		window:event(\"attacks\")\n"
	"	end\n"
	"end, 100)\n"
	"\n"
	"naim.hooks.add('proto_chat_user_nickchanged', function(conn, chat, who, newnick)\n"
	"	local group = conn.groups[string.lower(chat)]\n"
	"\n"
	"	assert(not group.members[newnick])\n"
	"	group.members[newnick] = group.members[who]\n"
	"	group.members[who] = nil\n"
	"\n"
	"	window:event(\"misc\", \"<font color=\\\"#00FFFF\\\">\" .. who .. \"</font> is now known as <font color=\\\"#00FFFF\\\">\" .. newnick .. \"</font>.\")\n"
	"end, 100)\n"
	"\n"
	"naim.hooks.add('proto_chat_topicchanged', function(conn, chat, topic, by)\n"
	"	local group = conn.groups[string.lower(chat)]\n"
	"	local window = conn.windows[string.lower(chat)]\n"
	"\n"
	"	group.topic = topic\n"
	"\n"
	"	if window then\n"
	"		if by and by ~= \"\" then\n"
	"			window:event(\"misc\", \"<font color=\\\"#00FFFF\\\">\" .. by .. \"</font> has changed the topic on group \" .. chat .. \" to </B><body>\" .. topic .. \"</body><B>.\")\n"
	"		else\n"
	"			window:event(\"misc\", \"Topic for group \" .. chat .. \": </B><body>\" .. topic .. \"</body><B>.\")\n"
	"		end\n"
	"	end\n"
	"end, 100)\n"
	"\n"
	"--naim.hooks.add('preselect', function(rfd, wfd, efd, maxfd)\n"
	"--	for k,v in pairs(naim.sockets) do\n"
	"--	end\n"
	"--end, 100)\n"
	"\n"
	"--naim.hooks.add('postselect', function(rfd, wfd, efd)\n"
	"--	for k,v in pairs(naim.sockets) do\n"
	"--	end\n"
	"--end, 100)\n"
;
