
#include <naim/naim.h>
#include "naim-int.h"
#include "cmdar.h"

cmdar_t	cmdar[] = {

	{ "jump",	ua_jump,	{ NULL },	"Go to the specified window or the next 'active' one",	{ { 0, 'W', "winname" }, { -1, -1, NULL } },	0,	1,	C_ANYWHERE },
	{ "msg",	ua_msg,	{ "m", "im", NULL },	"Send a message; as in /msg naimhelp naim is cool!",	{ { 1, 'W', "name" }, { 1, 's', "message" }, { -1, -1, NULL } },	2,	2,	C_ANYWHERE },
	{ "addbuddy",	ua_addbuddy,	{ "add", "friend", NULL },	"Add someone to your buddy list or change their group membership",	{ { 1, 'A', "account" }, { 0, 's', "group" }, { 0, 's', "realname" }, { -1, -1, NULL } },	1,	3,	C_ANYWHERE },
	{ "exit",	ua_exit,	{ "quit", NULL },	"Disconnect and exit naim",	{ { -1, -1, NULL } },	0,	0,	C_ANYWHERE },
	{ "save",	ua_save,	{ NULL },	"Write current settings to ~/.naimrc to be loaded at startup",	{ { 0, 's', "filename" }, { -1, -1, NULL } },	0,	1,	C_ANYWHERE },
	{ "connect",	ua_connect,	{ NULL },	"Connect to a service",	{ { 0, 's', "name" }, { 0, 's', "server" }, { 0, 'i', "port" }, { -1, -1, NULL } },	0,	3,	C_ANYWHERE },
	{ "jumpback",	ua_jumpback,	{ NULL },	"Go to the previous window",	{ { -1, -1, NULL } },	0,	0,	C_ANYWHERE },
	{ "info",	ua_info,	{ "whois", "wi", NULL },	"Retrieve a user profile",	{ { 0, 'E', "name" }, { -1, -1, NULL } },	0,	1,	C_ANYWHERE },
	{ "eval",	ua_eval,	{ NULL },	"Evaluate a command with $-variable substitution",	{ { 1, 's', "script" }, { -1, -1, NULL } },	1,	1,	C_ANYWHERE },
	{ "say",	ua_say,	{ NULL },	"Send a message to the current window; as in /say I am happy",	{ { 1, 's', "message" }, { -1, -1, NULL } },	1,	1,	C_NOTSTATUS },
	{ "me",	ua_me,	{ NULL },	"Send an 'action' message to the current window; as in /me is happy",	{ { 1, 's', "message" }, { -1, -1, NULL } },	1,	1,	C_NOTSTATUS },
	{ "open",	ua_open,	{ "window", NULL },	"Open a query window for an existing or new buddy by account",	{ { 1, 'A', "name" }, { -1, -1, NULL } },	1,	1,	C_ANYWHERE },
	{ "openbuddy",	ua_openbuddy,	{ NULL },	"Open a query window for an existing buddy by account or friendly name",	{ { 1, 'B', "name" }, { -1, -1, NULL } },	1,	1,	C_ANYWHERE },
	{ "close",	ua_close,	{ "endwin", "part", NULL },	"Close a query window or leave a discussion",	{ { 0, 'W', "winname" }, { -1, -1, NULL } },	0,	1,	C_NOTSTATUS },
	{ "closeall",	ua_closeall,	{ NULL },	"Close stale windows for offline buddies",	{ { -1, -1, NULL } },	0,	0,	C_ANYWHERE },
	{ "ctcp",	ua_ctcp,	{ NULL },	"Send Client To Client Protocol request to someone",	{ { 1, 'W', "name" }, { 0, 's', "requestname" }, { 0, 's', "message" }, { -1, -1, NULL } },	1,	3,	C_ANYWHERE },
	{ "clear",	ua_clear,	{ NULL },	"Temporarily blank the scrollback for the current window",	{ { -1, -1, NULL } },	0,	0,	C_ANYWHERE },
	{ "clearall",	ua_clearall,	{ NULL },	"Perform a /clear on all open windows",	{ { -1, -1, NULL } },	0,	0,	C_ANYWHERE },
	{ "load",	ua_load,	{ NULL },	"Load a command file (such as .naimrc)",	{ { 1, 'F', "filename" }, { -1, -1, NULL } },	1,	1,	C_ANYWHERE },
	{ "away",	ua_away,	{ NULL },	"Set or unset away status",	{ { 0, 's', "message" }, { -1, -1, NULL } },	0,	1,	C_ANYWHERE },
	{ "buddylist",	ua_buddylist,	{ NULL },	"Display buddy list",	{ { 0, 's', "type" }, { -1, -1, NULL } },	0,	1,	C_ANYWHERE },
	{ "join",	ua_join,	{ NULL },	"Participate in a chat",	{ { 1, 's', "chat" }, { 0, 's', "key" }, { -1, -1, NULL } },	1,	2,	C_ANYWHERE },
	{ "namebuddy",	ua_namebuddy,	{ NULL },	"Change the real name for a buddy",	{ { 1, 'A', "name" }, { 0, 's', "realname" }, { -1, -1, NULL } },	1,	2,	C_ANYWHERE },
	{ "groupbuddy",	ua_groupbuddy,	{ NULL },	"Change the group membership for a buddy",	{ { 1, 'A', "account" }, { 0, 's', "group" }, { -1, -1, NULL } },	1,	2,	C_ANYWHERE },
	{ "tagbuddy",	ua_tagbuddy,	{ "tag", NULL },	"Mark a buddy with a reminder message",	{ { 1, 'A', "name" }, { 0, 's', "note" }, { -1, -1, NULL } },	1,	2,	C_ANYWHERE },
	{ "delbuddy",	ua_delbuddy,	{ NULL },	"Remove someone from your buddy list",	{ { 0, 'A', "name" }, { -1, -1, NULL } },	0,	1,	C_ANYWHERE },
	{ "op",	ua_op,	{ NULL },	"Give operator privilege",	{ { 1, 'M', "name" }, { -1, -1, NULL } },	1,	1,	C_INCHAT },
	{ "deop",	ua_deop,	{ NULL },	"Remove operator privilege",	{ { 1, 'M', "name" }, { -1, -1, NULL } },	1,	1,	C_INCHAT },
	{ "topic",	ua_topic,	{ NULL },	"View or change current chat topic",	{ { 0, 's', "topic" }, { -1, -1, NULL } },	0,	1,	C_INCHAT },
	{ "kick",	ua_kick,	{ NULL },	"Temporarily remove someone from a chat",	{ { 1, 'M', "name" }, { 0, 's', "reason" }, { -1, -1, NULL } },	1,	2,	C_INCHAT },
	{ "invite",	ua_invite,	{ NULL },	"Invite someone to a chat",	{ { 1, 'A', "name" }, { 0, 's', "chat" }, { -1, -1, NULL } },	1,	2,	C_INCHAT },
	{ "unblock",	ua_unblock,	{ "unignore", NULL },	"Remove someone from the ignore list",	{ { 1, 'I', "name" }, { -1, -1, NULL } },	1,	1,	C_ANYWHERE },
	{ "block",	ua_block,	{ NULL },	"Server-enforced /ignore",	{ { 1, 'A', "name" }, { 0, 's', "reason" }, { -1, -1, NULL } },	1,	2,	C_ANYWHERE },
	{ "ignore",	ua_ignore,	{ NULL },	"Ignore all private/public messages",	{ { 0, 'A', "name" }, { 0, 's', "reason" }, { -1, -1, NULL } },	0,	2,	C_ANYWHERE },
	{ "chains",	ua_chains,	{ "tables", NULL },	"Manipulate data control tables",	{ { 0, 's', "chain" }, { -1, -1, NULL } },	0,	1,	C_ANYWHERE },
	{ "filter",	ua_filter,	{ NULL },	"Manipulate content filters",	{ { 0, 's', "table" }, { 0, 's', "target" }, { 0, 's', "action" }, { -1, -1, NULL } },	0,	3,	C_ANYWHERE },
	{ "warn",	ua_warn,	{ NULL },	"Send a warning about someone",	{ { 1, 'A', "name" }, { -1, -1, NULL } },	1,	1,	C_ANYWHERE },
	{ "nick",	ua_nick,	{ NULL },	"Change or reformat your name",	{ { 1, 's', "name" }, { -1, -1, NULL } },	1,	1,	C_ANYWHERE },
	{ "echo",	ua_echo,	{ NULL },	"Display something on the screen with $-variable expansion",	{ { 1, 's', "script" }, { -1, -1, NULL } },	1,	1,	C_ANYWHERE },
	{ "readprofile",	ua_readprofile,	{ NULL },	"Read your profile from disk",	{ { 1, 'F', "filename" }, { -1, -1, NULL } },	1,	1,	C_ANYWHERE },
	{ "accept",	ua_accept,	{ NULL },	"EXPERIMENTAL Accept a file transfer request in the current window",	{ { 1, 'W', "filename" }, { -1, -1, NULL } },	1,	1,	C_NOTSTATUS },
	{ "offer",	ua_offer,	{ NULL },	"EXPERIMENTAL Offer a file transfer request to someone",	{ { 1, 'A', "name" }, { 1, 'F', "filename" }, { -1, -1, NULL } },	2,	2,	C_ANYWHERE },
	{ "setcol",	ua_setcol,	{ NULL },	"View or change display colors",	{ { 0, 's', "eventname" }, { 0, 's', "colorname" }, { 0, 's', "colormodifier" }, { -1, -1, NULL } },	0,	3,	C_ANYWHERE },
	{ "setpriv",	ua_setpriv,	{ NULL },	"Change your privacy mode",	{ { 1, 's', "mode" }, { -1, -1, NULL } },	1,	1,	C_ANYWHERE },
	{ "bind",	ua_bind,	{ NULL },	"View or change key bindings",	{ { 0, 's', "keyname" }, { 0, 's', "script" }, { -1, -1, NULL } },	0,	2,	C_ANYWHERE },
	{ "alias",	ua_alias,	{ NULL },	"Create a new command alias",	{ { 1, 's', "commandname" }, { 1, 's', "script" }, { -1, -1, NULL } },	2,	2,	C_ANYWHERE },
	{ "set",	ua_set,	{ NULL },	"View or change the value of a configuration or session variable; see /help settings",	{ { 0, 'V', "varname" }, { 0, 's', "value" }, { 0, 's', "dummy" }, { -1, -1, NULL } },	0,	3,	C_ANYWHERE },
	{ "newconn",	ua_newconn,	{ NULL },	"Open a new connection window",	{ { 0, 's', "label" }, { 0, 's', "protocol" }, { -1, -1, NULL } },	0,	2,	C_ANYWHERE },
	{ "delconn",	ua_delconn,	{ NULL },	"Close a connection window",	{ { 0, 's', "label" }, { -1, -1, NULL } },	0,	1,	C_ANYWHERE },
	{ "server",	ua_server,	{ NULL },	"Connect to a service",	{ { 0, 's', "server" }, { 0, 'i', "port" }, { -1, -1, NULL } },	0,	2,	C_ANYWHERE },
	{ "disconnect",	ua_disconnect,	{ NULL },	"Disconnect from a server",	{ { -1, -1, NULL } },	0,	0,	C_ANYWHERE },
	{ "winlist",	ua_winlist,	{ NULL },	"Switch the window list window between always visible or always hidden or auto-hidden",	{ { 0, 's', "visibility" }, { -1, -1, NULL } },	0,	1,	C_ANYWHERE },
	{ "exec",	ua_exec,	{ NULL },	"Execute a shell command; as in /exec -o uname -a",	{ { 1, 's', "command" }, { -1, -1, NULL } },	1,	1,	C_ANYWHERE },
	{ "dlsym",	ua_dlsym,	{ NULL },	NULL,	{ { 1, 's', "symbol" }, { -1, -1, NULL } },	1,	1,	C_ANYWHERE },
	{ "modlist",	ua_modlist,	{ NULL },	"Search for and list all potential and resident naim modules",	{ { -1, -1, NULL } },	0,	0,	C_ANYWHERE },
	{ "modload",	ua_modload,	{ NULL },	"Load and initialize a dynamic module",	{ { 1, 'F', "module" }, { 0, 's', "options" }, { -1, -1, NULL } },	1,	2,	C_ANYWHERE },
	{ "modunload",	ua_modunload,	{ NULL },	"Deinitialize and unload a resident module",	{ { 1, 's', "module" }, { -1, -1, NULL } },	1,	1,	C_ANYWHERE },
	{ "resize",	ua_resize,	{ NULL },	"Resize all windows",	{ { 0, 'i', "height" }, { -1, -1, NULL } },	0,	1,	C_ANYWHERE },
	{ "status",	ua_status,	{ NULL },	"Connection status report",	{ { 0, 's', "connection" }, { -1, -1, NULL } },	0,	1,	C_ANYWHERE },

};
const int cmdc = sizeof(cmdar)/sizeof(*cmdar);

